Bug 1494981 - Review Request: webkit2-sharp - C# bindings for WebKit 2 with GTK+ 3
Summary: Review Request: webkit2-sharp - C# bindings for WebKit 2 with GTK+ 3
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Luya Tshimbalanga
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 1151172
TreeView+ depends on / blocked
 
Reported: 2017-09-24 15:43 UTC by Robert-André Mauchin 🐧
Modified: 2017-10-05 21:02 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-10-05 21:02:09 UTC
Type: Bug
luya: fedora-review+


Attachments (Terms of Use)

Comment 2 Luya Tshimbalanga 2017-09-25 05:08:00 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated


Issues:
=======
- Static libraries in -static or -devel subpackage, providing -devel if
  present.
  Note: Package has .a files: webkit2-sharp-devel. Does not provide
  -static: webkit2-sharp-devel.
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#StaticLibraries
- If (and only if) the source package includes the text of the license(s)
  in its own file, then that file, containing the text of the license(s)
  for the package is included in %license.
  Note: License file COPYING is not marked as %license
  See:
  http://fedoraproject.org/wiki/Packaging/LicensingGuidelines#License_Text


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[!]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory. Verify they are not in ld path.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "MIT/X11 (BSD like)", "Unknown or generated". 22 files have
     unknown license. Detailed output of licensecheck in
     /home/luya/Documents/fedora-
     packaging/review/1494981-webkit2-sharp/licensecheck.txt
[!]: License file installed when any subpackage combination is installed.
[-]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/lib/monodoc/sources,
     /usr/share/gapi-3.0, /usr/lib/monodoc
[x]: Package does not own files or directories owned by other packages.
     Note: Dirs in package are owned also by: /usr/lib/mono(webkit-sharp,
     mono-core), /usr/lib/mono/gac(webkit-sharp, mono-core, gnome-sharp,
     gtk-sharp2)
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in webkit2
     -sharp-devel
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[x]: Scriptlets must be sane, if used.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Package should not use obsolete m4 macros
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: webkit2-sharp-0-0.2.20170219gita59fd76.fc26.x86_64.rpm
          webkit2-sharp-devel-0-0.2.20170219gita59fd76.fc26.x86_64.rpm
          webkit2-sharp-0-0.2.20170219gita59fd76.fc26.src.rpm

webkit2-sharp.x86_64: W: unstripped-binary-or-object /usr/lib64/libwebkit2sharpglue-2.10.9.so
- See https://stg.fedoraproject.org/wiki/Common_Rpmlint_issues?rd=PackageMaintainers/Common_Rpmlint_Issues#unstripped-binary-or-object

webkit2-sharp.x86_64: W: wrong-file-end-of-line-encoding /usr/share/doc/webkit2-sharp/COPYING
- Assign COPYING to %license

webkit2-sharp-devel.x86_64: W: no-documentation

The lines below can be ignored per mono packaging guideline:
webkit2-sharp.src:75: E: hardcoded-library-path in %{_prefix}/lib/mono/
webkit2-sharp.src:82: E: hardcoded-library-path in %{_prefix}/lib/monodoc/sources/webkit2-sharp*
3 packages and 0 specfiles checked; 2 errors, 3 warnings.



Please fix the following:
Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory

webkit2-sharp.x86_64: W: unstripped-binary-or-object /usr/lib64/libwebkit2sharpglue-2.10.9.so
webkit2-sharp.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libwebkit2sharpglue-2.10.9.so /lib64/libwebkit2gtk-4.0.so.37
webkit2-sharp.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libwebkit2sharpglue-2.10.9.so /lib64/libgtk-3.so.0
webkit2-sharp.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libwebkit2sharpglue-2.10.9.so /lib64/libgdk-3.so.0
webkit2-sharp.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libwebkit2sharpglue-2.10.9.so /lib64/libpangocairo-1.0.so.0
webkit2-sharp.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libwebkit2sharpglue-2.10.9.so /lib64/libpango-1.0.so.0
webkit2-sharp.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libwebkit2sharpglue-2.10.9.so /lib64/libatk-1.0.so.0
webkit2-sharp.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libwebkit2sharpglue-2.10.9.so /lib64/libcairo-gobject.so.2
webkit2-sharp.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libwebkit2sharpglue-2.10.9.so /lib64/libcairo.so.2
webkit2-sharp.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libwebkit2sharpglue-2.10.9.so /lib64/libgdk_pixbuf-2.0.so.0
webkit2-sharp.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libwebkit2sharpglue-2.10.9.so /lib64/libsoup-2.4.so.1
webkit2-sharp.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libwebkit2sharpglue-2.10.9.so /lib64/libgio-2.0.so.0
webkit2-sharp.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libwebkit2sharpglue-2.10.9.so /lib64/libgobject-2.0.so.0
webkit2-sharp.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libwebkit2sharpglue-2.10.9.so /lib64/libjavascriptcoregtk-4.0.so.18
webkit2-sharp.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libwebkit2sharpglue-2.10.9.so /lib64/libglib-2.0.so.0

- Use "sed -i -e 's! -shared ! -Wl,--as-needed\0!g' libtool" at the %configure line (See https://stg.fedoraproject.org/wiki/Common_Rpmlint_issues?rd=PackageMaintainers/Common_Rpmlint_Issues#unused-direct-shlib-dependency)


webkit2-sharp.x86_64: W: wrong-file-end-of-line-encoding /usr/share/doc/webkit2-sharp/COPYING
- Use " sed -i 's/\r$//' <file_to_strip> " for COPYING  (See https://stg.fedoraproject.org/wiki/Common_Rpmlint_issues?rd=PackageMaintainers/Common_Rpmlint_Issues#wrong-file-end-of-line-encoding)

Comment 4 Luya Tshimbalanga 2017-09-25 17:37:53 UTC
It looks like you sent the wrong files as comment #3 lacks the reflected changes from comment #2.

Comment 6 Luya Tshimbalanga 2017-09-25 18:59:44 UTC
Skipping all passed reviews and focusing on the remaining:

webkit2-sharp.x86_64: W: unstripped-binary-or-object /usr/lib64/libwebkit2sharpglue-2.10.9.so
- Set that part as executable. For example "chmod +x /usr/lib64/libwebkit2sharpglue-2.10.9.so"

Make sure to update the changelog for tracking the changes. Once you completed the correction, I will approve the package.

Comment 7 Robert-André Mauchin 🐧 2017-09-25 20:16:56 UTC
Even with:

chmod 0755 %{buildroot}%{_libdir}/libwebkit2sharpglue-2.10.9.so

I still have:

 webkit2-sharp.x86_64: W: unstripped-binary-or-object /usr/lib64/libwebkit2sharpglue-2.10.9.so

That's why I didn't try it usually doesn't work.

SPEC URL: https://raw.githubusercontent.com/eclipseo/packaging/143f5cc/webkit2-sharp.spec

SRPM URL: https://copr-be.cloud.fedoraproject.org/results/eclipseo/sparkleshare/fedora-rawhide-x86_64/00607797-webkit2-sharp/webkit2-sharp-0-0.3.20170219gita59fd76.fc28.src.rpm

Comment 8 Luya Tshimbalanga 2017-09-25 20:50:28 UTC
When looking for solution, one suggestion will be using devel packages for BuildRequires instead of pkgconfig. Until a proper resolution will be addressed on the guideline about -devel vs pkconfig, it is currently safe to ignore the warning for now.
Therefore this package is approved.

Comment 9 Gwyn Ciesla 2017-09-26 18:24:03 UTC
(fedrepo-req-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/webkit2-sharp

Comment 10 Fedora Update System 2017-09-27 06:59:17 UTC
webkit2-sharp-0-0.3.20170219gita59fd76.fc27 has been submitted as an update to Fedora 27. https://bodhi.fedoraproject.org/updates/FEDORA-2017-8669a0e23a

Comment 11 Fedora Update System 2017-09-27 15:53:49 UTC
webkit2-sharp-0-0.3.20170219gita59fd76.fc27 has been pushed to the Fedora 27 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-8669a0e23a

Comment 12 Fedora Update System 2017-10-05 21:02:09 UTC
webkit2-sharp-0-0.3.20170219gita59fd76.fc27 has been pushed to the Fedora 27 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.